RogueMoveCaller_enabled = 1;
RogueMoveCaller_frame = 1;
RogueMoveCaller_inCombat = 0;
RogueMoveCaller_finisher1_cp = 5;
RogueMoveCaller_finisher2_cp = 5;

function RogueMoveCaller_OnLoad(self)
	SLASH_ROGUEMOVECALLER1 = "/roguemovecaller";
	SLASH_ROGUEMOVECALLER2 = "/rmc";
	SlashCmdList["ROGUEMOVECALLER"] = RogueMoveCaller_Command;
	self:RegisterEvent("PLAYER_REGEN_DISABLED");
	self:RegisterEvent("PLAYER_REGEN_ENABLED");
	self:RegisterEvent("UNIT_POWER");
end

function RogueMoveCaller_Command(cmd)
	cmd = string.lower(cmd);
	if (cmd == "enable") then
		RogueMoveCaller_enabled = 1;
		DEFAULT_CHAT_FRAME:AddMessage("RMC Enabled");

	elseif (cmd == "disable") then
		RogueMoveCaller_enabled = 0;
		DEFAULT_CHAT_FRAME:AddMessage("RMC Disabled");

	elseif (cmd == "frame") then
		DEFAULT_CHAT_FRAME:AddMessage("Enter /rmc frame # to choose which frame to display RMC in");
		DEFAULT_CHAT_FRAME:AddMessage("1 = Chat");
		DEFAULT_CHAT_FRAME:AddMessage("2 = Error");
		if IsAddOnLoaded("SCT") then
			DEFAULT_CHAT_FRAME:AddMessage("3 = SCT Message Frame");
		end
		DEFAULT_CHAT_FRAM:AddMessage("Current frame: "..RogueMoveCaller_frame);

	elseif (cmd == "frame 1") then
		RogueMoveCaller_frame = 1;
		DEFAULT_CHAT_FRAME:AddMessage("Using chat frame");

	elseif (cmd == "frame 2") then
		RogueMoveCaller_frame = 2;
		DEFAULT_CHAT_FRAME:AddMessage("Using error frame");

	elseif (cmd == "frame 3" and IsAddOnLoaded("SCT")) then
		RogueMoveCaller_frame = 3;
		DEFAULT_CHAT_FRAME:AddMessage("Using SCT Message frame");

	elseif (cmd == "frame 3" and not IsAddOnLoaded("SCT")) then
		DEFAULT_CHAT_FRAME:AddMessage("SCT not loaded!");

	elseif (cmd == "finisher1") then
		DEFAULT_CHAT_FRAME:AddMessage("Enter /rmc finisher1 # to choose the number of CPs to use for the first finisher (5 is default)");
	
	elseif (cmd == "finisher1 1") then
		RogueMoveCaller_finisher1_cp = 1;
		DEFAULT_CHAT_FRAME:AddMessage("Using 1cp on the first finisher");

	elseif (cmd == "finisher1 2") then
		RogueMoveCaller_finisher1_cp = 2;
		DEFAULT_CHAT_FRAME:AddMessage("Using 2cps on the first finisher");

	elseif (cmd == "finisher1 3") then
		RogueMoveCaller_finisher1_cp = 3;
		DEFAULT_CHAT_FRAME:AddMessage("Using 3cps on the first finisher");

	elseif (cmd == "finisher1 4") then
		RogueMoveCaller_finisher1_cp = 4;
		DEFAULT_CHAT_FRAME:AddMessage("Using 4cps on the first finisher");

	elseif (cmd == "finisher1 5") then
		RogueMoveCaller_finisher1_cp = 5;
		DEFAULT_CHAT_FRAME:AddMessage("Using 5cps on the first finisher");

	elseif (cmd == "finisher2") then
		DEFAULT_CHAT_FRAME:AddMessage("Enter /rmc finisher2 # to choose the number of CPs to use for the second finisher (5 is default)");

	elseif (cmd == "finisher2 1") then
		RogueMoveCaller_finisher2_cp = 1;
		DEFAULT_CHAT_FRAME:AddMessage("Using 1cp on the second finisher");

	elseif (cmd == "finisher2 2") then
		RogueMoveCaller_finisher2_cp = 2;
		DEFAULT_CHAT_FRAME:AddMessage("Using 2cps on the second finisher");

	elseif (cmd == "finisher2 3") then
		RogueMoveCaller_finisher2_cp = 3;
		DEFAULT_CHAT_FRAME:AddMessage("Using 3cps on the second finisher");

	elseif (cmd == "finisher2 4") then
		RogueMoveCaller_finisher2_cp = 4;
		DEFAULT_CHAT_FRAME:AddMessage("Using 4cps on the second finisher");

	elseif (cmd == "finisher2 5") then
		RogueMoveCaller_finisher2_cp = 5;
		DEFAULT_CHAT_FRAME:AddMessage("Using 5cps on the second finisher");

	else
		DEFAULT_CHAT_FRAME:AddMessage("RMC Commands:");
		if RogueMoveCaller_enabled == 0 then
			DEFAULT_CHAT_FRAME:AddMessage("RMC is disabled");
		end
		DEFAULT_CHAT_FRAME:AddMessage("/rmc enable    : Enable RMC");
		DEFAULT_CHAT_FRAME:AddMessage("/rmc disable   : Disable RMC");
		DEFAULT_CHAT_FRAME:AddMessage("/rmc frame     : Change the frame RMC displays in");
		DEFAULT_CHAT_FRAME:AddMessage("/rmc finisher1 : Change the number of cps used in the first finisher"); 
		DEFAULT_CHAT_FRAME:AddMessage("/rmc finisher2 : Change the number of cps used in the second finisher");
	end
end

function RogueMoveCaller_OnEvent(self, event, ...)
	local name,rank,icon,cost = GetSpellInfo("Sinister Strike");
	SS_Cost = cost;
	local name,rank,icon,cost = GetSpellInfo("Slice and Dice");
	SnD_Cost = cost;
	local name,rank,icon,cost = GetSpellInfo("Eviscerate");
	Rup_Cost = cost;
	local name, rank, icon, count, debuffType, duration, expiration = UnitBuff("player", "Slice and Dice");
	local SnD_Time = nil;
	if (expiration ~= nil) then
		SnD_Time = expiration - GetTime();
	end
	local energy = UnitPower("player");
	local cp = UnitPower("player", SPELL_POWER_COMBO_POINTS);
	

	if (event == "PLAYER_REGEN_DISABLED") then
		RogueMoveCaller_inCombat = 1;
	elseif (event == "PLAYER_REGEN_ENABLED") then
		RogueMoveCaller_inCombat = 0;
	elseif (event == "UNIT_POWER" and RogueMoveCaller_inCombat == 1 and RogueMoveCaller_enabled == 1) then
		end
		if(cp >= RogueMoveCaller_finisher1_cp and (SnD_Time == nil or SnD_Time < 10) and energy >= SnD_Cost) then
			if(RogueMoveCaller_frame == 1 or (RogueMoveCaller_frame == 3 and not IsAddOnLoaded("SCT"))) then
				DEFAULT_CHAT_FRAME:AddMessage("Slice and Dice!");
			elseif(RogueMoveCaller_frame == 2) then
				UIErrorsFrame:AddMessage("Slice and Dice!");
			elseif(RogueMoveCaller_frame == 3 and IsAddOnLoaded("SCT")) then
				SCT_MSG_FRAME:AddMessage("Slice and Dice!");
			end
		elseif(cp >= RogueMoveCaller_finisher2_cp and energy >= Rup_Cost) then
			if(RogueMoveCaller_frame == 1 or (RogueMoveCaller_frame == 3 and not IsAddOnLoaded("SCT"))) then
				DEFAULT_CHAT_FRAME:AddMessage("Eviscerate!");
			elseif(RogueMoveCaller_frame == 2) then
				UIErrorsFrame:AddMessage("Eviscerate!");
			elseif(RogueMoveCaller_frame == 3 and IsAddOnLoaded("SCT")) then
				SCT_MSG_FRAME:AddMessage("Eviscerate!");
			end
		elseif(energy >= SS_Cost) then
			if(RogueMoveCaller_frame == 1 or (RogueMoveCaller_frame == 3 and not IsAddOnLoaded("SCT"))) then
				DEFAULT_CHAT_FRAME:AddMessage("Sinister Strike!");
			elseif(RogueMoveCaller_frame == 2) then
				UIErrorsFrame:AddMessage("Sinister Strike!");
			elseif(RogueMoveCaller_frame == 3 and IsAddOnLoaded("SCT")) then
				SCT_MSG_FRAME:AddMessage("Sinister Strike!");
			end
		end
	end
end


